
function [k,ps] = fourier1D(profX,pixel_size) 
% FOURIER1D calculates the power spectrum of a 1D signal 
%Input parameters: 
% profX      => a linearly spaced vector containing the hights of a 1D-signal  
% pixel_size => distance beteween points of the vector profX 
% Output parameters: 
% k          => wave number (m^-1) 
% ps         => power spectrum  
  
% calculate the power spectrum 
nx   = length(profX); 
fftx = fft(profX); 
ps   = fftx .* conj(fftx)/length(profX); 
ps   = ps(1:length(profX)/2+1); 
  
%calculate the wave number (k) 
length_distance = nx*pixel_size; 
deltaf          = 1./length_distance; 
k               = deltaf:deltaf:1./pixel_size; 
k               = k(1:length(k)/2+1); 
k;

%////////////////////////////////////////////////////////////////////////// 
