function c = nonlin_cor_diff(l,k,ps,hs,hl)
% The function NONLIN_cor_diff describes the nonlinear behavior of the
% correlation function and calculates the differences between the original
% and the model for all points in the data range to create a vector valued
% function as imput for the LSQNONLIN function.
% compare functions in Appendix A for details.

c = zeros(size(k));
fx = zeros(size(k));
x = log(k);
L = l(1);
hL = l(2);

if nargin == 5 & length(l)==2
    Hs = hs;
    Hl = hl;
else
    Hs = l(3);
    Hl = l(4);
end

alpha_s = Hs;
alpha_l = Hl;
a = log(hL) + alpha_l*log(L);
b = log(hL) + alpha_s*log(L);
sx = (tanh(x+log(L))+1)./2;

for i=1:length(x)
    fx(i) = ((b + alpha_s*x(i))*(1-sx(i))) + ((a + alpha_l*x(i))*(sx(i)));
    c(i) = log(ps(i))-fx(i) ;
end

c = c';
