function c = nonlin_cor_model(l,k,hs,hl)
%The function NONLIN-FOURIER_MODEL calculates the modelled data using the
%minimized output values from LSQNONLIN over the defined data range.
% compare functions in Appendix A for details.

c = zeros(size(k));
fx = zeros(size(k));
x = log(k);
L = l(1);
hL = l(2);

if nargin == 4 & length(l) == 2
    Hs = hs;
    Hl = hl;
else
    Hs = l(3);
    Hl = l(4);
end

alpha_s = Hs;
alpha_l = Hl;
a = log(hL) + alpha_l*log(L);
b = log(hL) + alpha_s*log(L);
sx = (tanh(x+log(L))+1)./2;

for i=1:length(x)
    c(i) = ((b + alpha_s*x(i))*(1-sx(i))) + ((a + alpha_l*x(i))*(sx(i)));
end

c=c';
